'''
Modify interscanners for sagator, version 0.6.0

(c) 2003-2004 Jan ONDREJ (SAL) <ondrejj@salstar.sk>

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
    
'''

from avlib import *
import re
from match import match_any

__all__=['modify_header','modify_subject']

class modify_header(match_any):
  '''
  modify_header() - modifying email headers

  usage: modify_header('^Header_regexp:','Header_regexp: prefix',scanners)
  
  where: prefix is an prefix added into Subject.
         There are some special pattern, which are replaced:
           %V ... virus name
           %S ... scanner name

  This scanner can be used to modify email headers.
  '''
  name='modify_header()'
  def __init__(self,frm,to,*scanners):
      self.ONLY_IF='.'
      self.MOD_FRM=frm
      self.MOD_TO=to
      match_any.__init__(self,scanners)
  def onlyif(self,pattern='.'):
      self.ONLY_IF=pattern
      return self
  def scanstream(self,stream):
      level,detected,virlist=match_any.scanstream(self,stream)
      if re.search(self.ONLY_IF,detected,re.IGNORECASE):
        mail.modheader(self.MOD_FRM,
                       re.sub("%V",detected,
                         re.sub("%S",globals.found_by.name,
                           self.MOD_TO)))
      return level,detected,virlist

class modify_subject(modify_header):
  '''
  modify_subject() - modifying email Subject

  usage: modify_subject('prefix',scanners)
  
  where: 'prefix' is an prefix added into Subject.
         For more information see modify_header() interscanner.

  This scanner can be used to modify email Subject.
  For example original Subject line is:
    Subject: Testing mail
  and i use:
    deliver(...).modify_subject('[SPAM]')
  Header will be modifyed to:
    Subject: [SPAM] Testing mail
  '''
  name='modify_subject()'
  def __init__(self,prefix,*scanners):
      modify_header.__init__(self,"^Subject:","Subject: "+prefix,scanners)
